
TYPO3.TYPO3CR - Task # 53335

Status: Resolved Priority: Should have
Author: Bastian Waidelich Category: Nodetype support
Created: 2013-11-05 Assigned To: Bastian Waidelich
Updated: 2013-12-04 Due date:
Sprint:
Description

Magic __call() methods have a lot of drawbacks. We should replace

$nodeType->getSomeFoo()

with

$nodeType->getConfiguration('someFoo');

Associated revisions
Revision 82a3e848 - 2013-11-21 17:41 - Bastian Waidelich

[!!!][TASK] Deprecate magic call method in NodeType

This deprecates the magic __call method in NodeType that was used to
check and retrieve single configuration options and replaces them
with two explicit methods ``hasConfiguration()`` and
``getConfiguration()``.

Background: magic __call methods have some severe drawbacks as they
are error prone, slow and hidden from IDEs.

This is not a breaking change in the technical sense because the
magic method still exists for compatibility reasons. But it replaces
the @api annotation by a @deprecated annotation requiring calling
code to adjust to the new API.
However, it replaces the (non-API) method ``getConfiguration()`` by
a new method ``getFullConfiguration()``.
History
#1 - 2013-11-05 12:09 - Bastian Waidelich

Obviously NodeType::getConfiguration() is a bad idea as that already returns the complete configuration. What about getConfigurationOption() or just 
getOption() ?

#2 - 2013-11-05 12:57 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.TYPO3CR has been pushed to the review server.
It is available at https://review.typo3.org/25173

#3 - 2013-11-06 12:11 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.TYPO3CR has been pushed to the review server.
It is available at https://review.typo3.org/25173

#4 - 2013-11-21 13:59 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.TYPO3CR has been pushed to the review server.
It is available at https://review.typo3.org/25173

#5 - 2013-11-21 18:35 - Bastian Waidelich
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:82a3e848c3bbcd68340eaeea13b297ba39027c09.

#6 - 2013-12-04 18:43 - Bastian Waidelich
- Target version set to 1.0 beta 2
